;-----------------------------------------------
; CI - Rotina para Autocad que desenha
; circuitos integrados encapsulamento
; DIL
;
; (c) Alexandre Erwin Ittner - 2001
; kernel32@bigfoot.com
; http://kernel32.cjb.net
;
;-----------------------------------------------



(defun c:ci(/ Dcl_Id)
	(SalvaConfUsuario)

	(setq TamanhoFonte 2)
	(setq DistanciaPinos 4)
	(setq DistTextoLinha 1)
	(setq TamanhoTerminal 2)
	(RetornaListaEstilosTexto)
	(setq NomeArqDialogo "DlgCI")


	(setq Dcl_Id (load_dialog NomeArqDialogo))

	(if (not (new_dialog "DlgCIInserir" Dcl_Id))
		(progn
			(alert (strcat "ERRO: Arquivo " NomeArqDialogo ".dcl no encontrado!"))
			(RestauraConfUsuario)
			(exit)
			)
		)


	(start_list "lsEstilosTexto")
	(foreach EstiloAtual ListaEstilosTexto 
		(add_list EstiloAtual)
		)
	(end_list)



	; Restaura informacoes, caso jah digitadas pelo usuario
	(if NomeCI
		(set_tile "txNomeCI" NomeCI)
		)
	(if FuncaoCI
		(set_tile "txFuncaoCI" FuncaoCI)
		)
	(if NumPinos
		(set_tile "txNumPinos" (itoa NumPinos))
		)
	(if LarguraDefinidaCI
		(set_tile "txLarguraDefinidaCI" (itoa LarguraDefinidaCI))
		)
	(if DesenharArco
		(set_tile "tgDesenharArco" DesenharArco)
		)
	(if EscalonarLargura
		(set_tile "tgEscalonarLargura" EscalonarLargura)
		)

	(cliqueTgEscalonarLargura) ;Atualiza estado do campo...


	(action_tile "btInserir"  "(CliqueBtInserir)")
	(action_tile "btCancelar" "(done_dialog 0)")
	(action_tile "btSobre"    "(MostraMsgSobre)")
	(action_tile "txNumPinos" "(FormataTxNumPinos)")
	(action_tile "tgEscalonarLargura" "(CliqueTgEscalonarLargura)")
	(action_tile "txLarguraDefinidaCI" "(FormataTxLarguraDefinidaCI)")


	(setq RetornoDialogo (start_dialog))
	(unload_dialog Dcl_Id)

	(if (= RetornoDialogo 1)
		(DesenhaCI)
		)

	(RestauraConfUsuario)
	(princ)
	)






(defun FormataTxNumPinos()
	;Deixa o numero de pinos inteiro positivo e par qdo o usuario
	;digitar um valor invalido

	(setq TempNumPinos (atoi (get_tile "txNumPinos")))
	(setq TempNumPinos (abs (* 2 (/ TempNumPinos 2))))
	(set_tile "txNumPinos" (itoa TempNumPinos))
	)






(defun FormataTxLarguraDefinidaCI()
	(setq TempLarguraDefinidaCI (atoi (get_tile "txLarguraDefinidaCI")))
	(set_tile "txLarguraDefinidaCI" (itoa (abs TempLarguraDefinidaCI)))
	)





(defun CliqueTgEscalonarLargura ()
	(setq EstadoToggle (get_tile "tgEscalonarLargura"))
	(if (= EstadoToggle "1")
		(mode_tile "txLarguraDefinidaCI" 1)
		(mode_tile "txLarguraDefinidaCI" 0)
		)
	)






(defun CliqueBtInserir()
	(setq NomeCI (get_tile "txNomeCI"))
	(setq FuncaoCI (get_tile "txFuncaoCI"))
	(setq StrNumPinos (get_tile "txNumPinos"))
	(setq DesenharArco (get_tile "tgDesenharArco"))
	(setq EscalonarLargura (get_tile "tgEscalonarLargura"))
	(setq strLarguraDefinidaCI (get_tile "txLarguraDefinidaCI"))

	(setq NumPinos (atoi StrNumPinos))
	(setq LarguraDefinidaCI (atoi strLarguraDefinidaCI))

	(setq IndiceEstiloTexto (atoi (get_tile "lsEstilosTexto")))
	(setq EstiloTexto (nth IndiceEstiloTexto ListaEstilosTexto))

	(if (and (= (rem NumPinos 2)) (not (zerop NumPinos)) (not (minusp NumPinos)))
		(if (= EscalonarLargura "1")
			(done_dialog 1)
			(if (not (zerop LarguraDefinidaCI))
				(done_dialog 1)
				(alert "Largura do CI invlida!")
				)
			)
		(progn
			(alert "O nmero de pinos deve ser positivo, inteiro e par!")
			(set_tile "txNumPinos" (itoa (* 2 (fix (/ NumPinos 2)))))
			)
		)
	)








(defun DesenhaCI()
	(setq PtoOrigem (getpoint "\nPonto de insercao: "))

	(setvar "osmode" 0) ; PARANOIA, o usuario pode ter setado algum osnap na hora de
			    ; escolher o ponto...


	(setq PtoOrigemX (nth 0 PtoOrigem))
	(setq PtoOrigemY (nth 1 PtoOrigem))
	(setq PtoOrigemZ (nth 2 PtoOrigem))

	(setq AlturaCI (fix (+ (* (/ NumPinos 2) DistanciaPinos) (/ DistanciaPinos 2))))


	(if (= EscalonarLargura "1")
		(setq LarguraCI	(max 
				(fix (/ AlturaCI 3))
				(fix (* TamanhoFonte (+ (strlen NomeCI) 6)))
				(fix (* TamanhoFonte (+ (strlen FuncaoCI) 6)))
				)
			)
		(setq LarguraCI	LarguraDefinidaCI)
		)


	(EMDesenhaLinha PtoOrigem
			(list (+ PtoOrigemX LarguraCI) PtoOrigemY)
			)
	(EMDesenhaLinha (list (+ PtoOrigemX LarguraCI) PtoOrigemY)
			(list (+ PtoOrigemX LarguraCI) (+ PtoOrigemY AlturaCI))
			)
	(EMDesenhaLinha (list (+ PtoOrigemX LarguraCI) (+ PtoOrigemY AlturaCI)) 
			(list PtoOrigemX (+ PtoOrigemY AlturaCI))
			)
	(EMDesenhaLinha (list PtoOrigemX (+ PtoOrigemY AlturaCI))
			PtoOrigem
			)
	
	(if (= DesenharArco "1")
		(EMDesenhaArco 	(list (+ PtoOrigemX (/ LarguraCI 2)) (+ PtoOrigemY AlturaCI))
				1 180 0
				)
		)


	(setq PtoCentroCIY (+ PtoOrigemY (/ AlturaCI 2)))

	(EMDesenhaTextoCentroCentro
		(list	(+ PtoOrigemX (/ LarguraCI 2))
			(+ PtoCentroCIY (/ TamanhoFonte 2.0) (/ DistTextoLinha 2.0))
			)
		NomeCI TamanhoFonte EstiloTexto
		)

	(EMDesenhaTextoCentroCentro
		(list	(+ PtoOrigemX (/ LarguraCI 2))
			(- PtoCentroCIY (/ TamanhoFonte 2.0) (/ DistTextoLinha 2.0))
			)
		FuncaoCI TamanhoFonte EstiloTexto
		)


	(setq PtoOrigemTextoEsqX (- (+ PtoOrigemX LarguraCI) DistTextoLinha))
	(setq PtoOrigemTextoY (- (+ PtoOrigemY (* (/ NumPinos 2) DistanciaPinos)) (/ TamanhoFonte 2)))

	(setq temp 0)
	(repeat (/ NumPinos 2)
		(EMDesenhaTextoDireitaCentro 
			(list PtoOrigemTextoEsqX (- PtoOrigemTextoY  (* temp DistanciaPinos)))
			(itoa (- NumPinos temp))
			TamanhoFonte
			EstiloTexto
			)
		(EMDesenhaLinha
			 (list (+ PtoOrigemX LarguraCI) (- PtoOrigemTextoY  (* temp DistanciaPinos)))
			 (list (+ PtoOrigemX LarguraCI TamanhoTerminal) (- PtoOrigemTextoY  (* temp DistanciaPinos)))
			 )
		(setq temp (1+ temp))
		)



	(setq PtoOrigemTextoDirX (+ PtoOrigemX DistTextoLinha))

	(setq temp 0)
	(repeat (/ NumPinos 2)
		(EMDesenhaTextoEsquerdaCentro
			(list PtoOrigemTextoDirX (- PtoOrigemTextoY  (* temp DistanciaPinos)))
			(itoa (1+ temp))
			TamanhoFonte
			EstiloTexto
			)
		(EMDesenhaLinha
			 (list PtoOrigemX (- PtoOrigemTextoY  (* temp DistanciaPinos)))
			 (list (- PtoOrigemX TamanhoTerminal) (- PtoOrigemTextoY  (* temp DistanciaPinos)))
			 )
		(setq temp (1+ temp))
		)



	(RestauraConfUsuario)
	(princ)
	)






(defun MostraMsgSobre()
	(alert (strcat
		"Circuito Integrado verso 1.0\n"
		"Criado por Alexandre Erwin Ittner - 2001\n"
		"kernel32@bigfoot.com\n"
		"http://kernel32.cjb.net\n\n"
		"Voc est autorizado a usar este programa e\n"
		"melhor-lo, desde que no altere esta mensagem\n"
		"e mantenha o cdigo fonte aberto.")
		)
	)






(defun SinalErro (MsgErro)
	(alert (strcat "Erro interno do AutoLISP: " MsgErro))
	(term_dialog)

	(RestauraConfUsuario)

	(princ (strcat "\nERRO: " MsgErro "\n"))
	(princ)
	)






(defun RestauraConfUsuario ()
	(setq *error* RotinaErroOriginal)

 	(setvar "cmdecho" EstadoEco)
	(setvar "osmode" EstadoOsnap)
	)





(defun SalvaConfUsuario ()
	(setq RotinaErroOriginal *error*)
	(setq *error* SinalErro)


	(setq EstadoEco (getvar "cmdecho"))
	(setvar "cmdecho" 0)

	(setq EstadoOsnap (getvar "osmode"))
	(setvar "osmode" 0)
	)

	


(defun RetornaListaEstilosTexto()
	(setq NomeEstiloTextoSelecionado (getvar "textstyle"))
	(setq ListaEstilosTexto (list NomeEstiloTextoSelecionado))

	(setq EstiloTextoAtual (tblnext "style" T))
	(while EstiloTextoAtual
		(setq NomeEstiloTextoAtual (cdr (assoc 2 EstiloTextoAtual)))
		(if (/= NomeEstiloTextoAtual NomeEstiloTextoSelecionado)
			(setq ListaEstilosTexto (append ListaEstilosTexto (list NomeEstiloTextoAtual)))
			)
		(setq EstiloTextoAtual (tblnext "style"))
		)
	)





(defun EMDesenhaLinha(PtoOrigemLinha PtoDestinoLinha)
	(entmake (list
			(cons 0  "LINE")
			(list 10 (nth 0 PtoOrigemLinha)
				 (nth 1 PtoOrigemLinha) 
				 0
				 )
			(list 11 (nth 0 PtoDestinoLinha)
				 (nth 1 PtoDestinoLinha)
				 0
				 )
			)
		)
	)




(defun EMDesenhaTextoCentroCentro (PtoOrigemTexto Texto TamanhoFonte EstiloTexto)
	(entmake (list
			(cons 0  "TEXT")
			(cons 1  Texto)
			(cons 7  EstiloTexto)
			(list 10 (nth 0 PtoOrigemTexto)
				 (nth 1 PtoOrigemTexto)
				 0
				 )
			(list 11 (nth 0 PtoOrigemTexto)
				 (nth 1 PtoOrigemTexto)
				 0
				 )
			(cons 40 TamanhoFonte)
			(cons 41 1)
			(cons 50 0)
			(cons 72 1)
			(cons 73 2)
			)
		)
	)



(defun EMDesenhaTextoDireitaCentro (PtoOrigemTexto Texto TamanhoFonte EstiloTexto)
	(entmake (list
			(cons 0  "TEXT")
			(cons 1  Texto)
			(cons 7  EstiloTexto)
			(list 10 (nth 0 PtoOrigemTexto)
				 (nth 1 PtoOrigemTexto)
				 0
				 )
			(list 11 (nth 0 PtoOrigemTexto)
				 (nth 1 PtoOrigemTexto)
				 0
				 )
			(cons 40 TamanhoFonte)
			(cons 41 1)
			(cons 50 0)
			(cons 72 2)
			(cons 73 2)
			)
		)
	)



(defun EMDesenhaTextoEsquerdaCentro (PtoOrigemTexto Texto TamanhoFonte EstiloTexto)
	(entmake (list
			(cons 0  "TEXT")
			(cons 1  Texto)
			(cons 7  EstiloTexto)
			(list 10 (nth 0 PtoOrigemTexto)
				 (nth 1 PtoOrigemTexto)
				 0
				 )
			(list 11 (nth 0 PtoOrigemTexto)
				 (nth 1 PtoOrigemTexto)
				 0
				 )
			(cons 40 TamanhoFonte)
			(cons 41 1)
			(cons 50 0)
			(cons 72 0)
			(cons 73 2)
			)
		)
	)




(defun EMDesenhaArco (PtoCentro Raio AngInicial AngFinal)
	(entmake (list 
			(cons 0 "ARC")
			(list 10 (nth 0 PtoCentro) (nth 1 PtoCentro) 0)
			(cons 40 Raio)
			(cons 50 (* AngInicial (/ pi 180.0)))
			(cons 51 (* AngFinal (/ pi 180.0)))
			)
		)
	)



